
#property copyright "Copyright  2007, FX5"
#property link      "hazem@uk2.net"
// Reprogram by SEFC (setting)
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Black

extern bool Grs_pandu = TRUE;
extern bool Peringatan = TRUE;
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
int g_bars_116;

int init() {
   IndicatorBuffers(8);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(0, g_ibuf_84);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(1, g_ibuf_88);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexBuffer(2, g_ibuf_92);
   SetIndexArrow(2, 217);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexBuffer(3, g_ibuf_96);
   SetIndexArrow(3, 218);
   SetIndexStyle(4, DRAW_NONE);
   SetIndexBuffer(4, g_ibuf_100);
   SetIndexBuffer(5, g_ibuf_104);
   SetIndexBuffer(6, g_ibuf_108);
   SetIndexBuffer(7, g_ibuf_112);
   SetIndexDrawBegin(0, 9);
   SetIndexDrawBegin(1, 9);
   IndicatorDigits(Digits + 2);
   IndicatorShortName("SEFC_Divergence");
   return (0);
}

int deinit() {
   string l_name_4;
   for (int li_0 = ObjectsTotal() - 1; li_0 >= 0; li_0--) {
      l_name_4 = ObjectName(li_0);
      if (StringSubstr(l_name_4, 0, 9) == "trendline") ObjectDelete(l_name_4);
   }
   return (0);
}

int start() {
   
   if (Bars < 1000 || 0) g_bars_116 = Bars;
   else g_bars_116 = 10000;
   int l_ind_counted_0 = IndicatorCounted();
   if (l_ind_counted_0 < 0) l_ind_counted_0 = 0;
   CalculateOsMA(l_ind_counted_0);
   CalculateDivergence(l_ind_counted_0);
   return (0);
}

void CalculateDivergence(int ai_0) {
   int li_16;
   double ld_20;
   int li_28;
   int li_32;
   int li_36;
   int li_40;
   double ld_44;
   double ld_52;
   double ld_60;
   double ld_68;
   int li_76;
   int li_80;
   int li_84;
   int li_88;
   double ld_92;
   double ld_100;
   double ld_108;
   double ld_116;
   double ld_4 = 50.0 * (1 / MathPow(10, Digits + 2));
   for (int li_12 = g_bars_116 - ai_0; li_12 >= 0; li_12--) {
      g_ibuf_96[li_12] = EMPTY_VALUE;
      g_ibuf_92[li_12] = EMPTY_VALUE;
      li_16 = GetFirstPeakOrTrough(li_12);
      ld_20 = g_ibuf_100[li_16];
      if (ld_20 > 0.0) {
         li_28 = GetIndicatorLastPeak(li_12);
         li_32 = GetIndicatorLastTrough(li_28);
         li_36 = GetIndicatorLastPeak(li_32);
         li_40 = GetIndicatorLastTrough(li_36);
      } else {
         li_32 = GetIndicatorLastTrough(li_12);
         li_28 = GetIndicatorLastPeak(li_32);
         li_40 = GetIndicatorLastTrough(li_28);
         li_36 = GetIndicatorLastPeak(li_40);
      }
      if (li_28 == -1 || li_36 == -1 || li_32 == -1 || li_40 == -1) continue;
      ld_44 = g_ibuf_100[li_28];
      ld_52 = g_ibuf_100[li_36];
      ld_60 = g_ibuf_100[li_32];
      ld_68 = g_ibuf_100[li_40];
      li_76 = li_28;
      li_80 = li_36;
      li_84 = li_32;
      li_88 = li_40;
      ld_92 = High[li_76];
      ld_100 = High[li_80];
      ld_108 = Low[li_84];
      ld_116 = Low[li_88];
      if (ld_92 > ld_100 && ld_44 < ld_52) {
         DisplayAlert("Bearish divergence pd: ", li_12, li_76);
         g_ibuf_96[li_28] = g_ibuf_84[li_28] + ld_4;
         if (Grs_pandu) {
            PriceDrawLine(Time[li_76], Time[li_80], ld_92, ld_100, Red, STYLE_SOLID);
            IndicatorDrawLine(Time[li_28], Time[li_36], ld_44, ld_52, Red, STYLE_SOLID);
         }
      } else {
         if (ld_92 < ld_100 && ld_44 > ld_52) {
            DisplayAlert("Reversal dr bearish ke bullish pd: ", li_12, li_76);
            g_ibuf_96[li_28] = g_ibuf_84[li_28] + ld_4;
            if (Grs_pandu) {
               PriceDrawLine(Time[li_76], Time[li_80], ld_92, ld_100, Fuchsia, STYLE_DOT);
               IndicatorDrawLine(Time[li_28], Time[li_36], ld_44, ld_52, Fuchsia, STYLE_DOT);
            }
         } else {
            if (ld_108 < ld_116 && ld_60 > ld_68) {
               DisplayAlert("Bullish divergence pd: ", li_12, li_84);
               g_ibuf_92[li_32] = g_ibuf_88[li_32] - ld_4;
               if (Grs_pandu) {
                  PriceDrawLine(Time[li_84], Time[li_88], ld_108, ld_116, LimeGreen, STYLE_SOLID);
                  IndicatorDrawLine(Time[li_32], Time[li_40], ld_60, ld_68, LimeGreen, STYLE_SOLID);
               }
            } else {
               if (ld_108 > ld_116 && ld_60 < ld_68) {
                  DisplayAlert("Reversal dr bullish ke bearish pada : ", li_12, li_84);
                  g_ibuf_92[li_32] = g_ibuf_88[li_32] - ld_4;
                  if (Grs_pandu) {
                     PriceDrawLine(Time[li_84], Time[li_88], ld_108, ld_116, DarkGreen, STYLE_DOT);
                     IndicatorDrawLine(Time[li_32], Time[li_40], ld_60, ld_68, DarkGreen, STYLE_DOT);
                  }
               }
            }
         }
      }
   }
}

void DisplayAlert(string as_0, int ai_8, int ai_12) {
   if (Peringatan == TRUE && ai_8 == 0 && g_ibuf_112[ai_12] != 1.0) {
      Alert(as_0, Symbol(), " -> di hrg :  ", Bid);
      g_ibuf_112[ai_12] = 1;
   }
}

void CalculateOsMA(int ai_0) {
   for (int li_4 = Bars - ai_0; li_4 >= 0; li_4--) g_ibuf_104[li_4] = iMA(NULL, 0, 9, 0, MODE_EMA, PRICE_CLOSE, li_4) - iMA(NULL, 0, 14, 0, MODE_EMA, PRICE_CLOSE, li_4);
   for (li_4 = Bars - ai_0; li_4 >= 0; li_4--) {
      g_ibuf_108[li_4] = iMAOnArray(g_ibuf_104, Bars, 9, 0, MODE_SMA, li_4);
      g_ibuf_100[li_4] = g_ibuf_104[li_4] - g_ibuf_108[li_4];
      if (g_ibuf_100[li_4] > 0.0) {
         g_ibuf_84[li_4] = g_ibuf_100[li_4];
         g_ibuf_88[li_4] = 0;
      } else {
         if (g_ibuf_100[li_4] < 0.0) {
            g_ibuf_88[li_4] = g_ibuf_100[li_4];
            g_ibuf_84[li_4] = 0;
         } else {
            g_ibuf_84[li_4] = 0;
            g_ibuf_88[li_4] = 0;
         }
      }
   }
}

int GetPositiveRegionStart(int ai_0) {
   for (int li_ret_8 = ai_0 + 1; li_ret_8 < Bars; li_ret_8++)
      if (g_ibuf_100[li_ret_8] >= g_ibuf_100[li_ret_8 - 1] && g_ibuf_100[li_ret_8] >= g_ibuf_100[li_ret_8 + 1] && g_ibuf_100[li_ret_8] >= g_ibuf_100[li_ret_8 + 2] && g_ibuf_100[li_ret_8] > 0.0001) return (li_ret_8);
   return (-1);
}

int GetNegativeRegionStart(int ai_0) {
   for (int li_ret_4 = ai_0 + 1; li_ret_4 < Bars; li_ret_4++)
      if (g_ibuf_100[li_ret_4] <= g_ibuf_100[li_ret_4 - 1] && g_ibuf_100[li_ret_4] <= g_ibuf_100[li_ret_4 + 1] && g_ibuf_100[li_ret_4] <= g_ibuf_100[li_ret_4 + 2] && g_ibuf_100[li_ret_4] < -0.0001) return (li_ret_4);
   return (-1);
}

int GetFirstPeakOrTrough(int ai_0) {
   for (int li_ret_4 = ai_0 + 1; li_ret_4 < Bars; li_ret_4++) {
      if ((g_ibuf_100[li_ret_4] >= g_ibuf_100[li_ret_4 - 1] && g_ibuf_100[li_ret_4] >= g_ibuf_100[li_ret_4 + 1] && g_ibuf_100[li_ret_4] >= g_ibuf_100[li_ret_4 + 2] && g_ibuf_100[li_ret_4] > 0.0001) ||
         (g_ibuf_100[li_ret_4] <= g_ibuf_100[li_ret_4 - 1] && g_ibuf_100[li_ret_4] <= g_ibuf_100[li_ret_4 + 1] && g_ibuf_100[li_ret_4] <= g_ibuf_100[li_ret_4 + 2] && g_ibuf_100[li_ret_4] < -0.0001)) return (li_ret_4);
   }
   return (-1);
}

int GetIndicatorLastPeak(int ai_0) {
   int li_4 = GetPositiveRegionStart(ai_0);
   if (li_4 == -1) return (-1);
   bool li_ret_8 = FALSE;
   double ld_12 = 0;
   for (int li_20 = li_4; li_20 < Bars; li_20++) {
      if (g_ibuf_100[li_20] > ld_12 && g_ibuf_100[li_20] >= g_ibuf_100[li_20 - 1] && g_ibuf_100[li_20] >= g_ibuf_100[li_20 + 1] && g_ibuf_100[li_20] >= g_ibuf_100[li_20 +
         2] && g_ibuf_100[li_20] > 0.0001) {
         ld_12 = g_ibuf_100[li_20];
         li_ret_8 = li_20;
      }
      if (g_ibuf_100[li_20] < 0.0) break;
   }
   return (li_ret_8);
}

int GetIndicatorLastTrough(int ai_0) {
   int li_4 = GetNegativeRegionStart(ai_0);
   if (li_4 == -1) return (-1);
   bool li_ret_8 = FALSE;
   double ld_12 = 0;
   for (int li_20 = li_4; li_20 < Bars; li_20++) {
      if (g_ibuf_100[li_20] < ld_12 && g_ibuf_100[li_20] <= g_ibuf_100[li_20 - 1] && g_ibuf_100[li_20] <= g_ibuf_100[li_20 + 1] && g_ibuf_100[li_20] <= g_ibuf_100[li_20 +
         2] && g_ibuf_100[li_20] < -0.0001) {
         ld_12 = g_ibuf_100[li_20];
         li_ret_8 = li_20;
      }
      if (g_ibuf_100[li_20] > 0.0) break;
   }
   return (li_ret_8);
}

void PriceDrawLine(int a_datetime_0, int a_datetime_4, double a_price_8, double a_price_16, color a_color_24, double a_style_28) {
   string l_name_36 = "trendlineP " + DoubleToStr(a_datetime_0, 0);
   ObjectDelete(l_name_36);
   ObjectCreate(l_name_36, OBJ_TREND, 0, a_datetime_0, a_price_8, a_datetime_4, a_price_16, 0, 0);
   ObjectSet(l_name_36, OBJPROP_RAY, FALSE);
   ObjectSet(l_name_36, OBJPROP_COLOR, a_color_24);
   ObjectSet(l_name_36, OBJPROP_STYLE, a_style_28);
}

void IndicatorDrawLine(int a_datetime_0, int a_datetime_4, double a_price_8, double a_price_16, color a_color_24, double a_style_28) {
   string l_name_40;
   int l_window_36 = WindowFind("SEFC_Divergence");
   if (l_window_36 >= 0) {
      l_name_40 = "trendlineIn " + DoubleToStr(a_datetime_0, 0);
      ObjectDelete(l_name_40);
      ObjectCreate(l_name_40, OBJ_TREND, l_window_36, a_datetime_0, a_price_8, a_datetime_4, a_price_16, 0, 0);
      ObjectSet(l_name_40, OBJPROP_RAY, FALSE);
      ObjectSet(l_name_40, OBJPROP_COLOR, a_color_24);
      ObjectSet(l_name_40, OBJPROP_STYLE, a_style_28);
   }
}